=== debian/changelog ===
neko (2.2.0-2) unstable; urgency=medium

  * Turned libapache2-mod-neko into Architecture: any.
    (Closes: #886427)
  * Bump Standards-Version to 4.1.3 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 08 Jan 2018 09:45:01 +0800

neko (2.2.0-1) unstable; urgency=low

  * New upstream version.
  * Removed patches applied to upstream.
  * Convert to multiarch.
  * Add dh_missing --fail-missing check.
  * Updated d/watch to match new upstream download links.
  * Bump Standards-Version to 4.1.2 (no changes).
  * Disable parallel build since it is only supported by upstream
    when using Ninja.
  * Add autopkgtest support.

 -- Andy Li <andy@onthewings.net>  Wed, 20 Dec 2017 10:43:17 +0800
