=== debian/watch ===
version=3
opts="uversionmangle=s/-/./g"\
 https://nekovm.org/download/ https://github.com/HaxeFoundation/neko/archive/v(\d\-\d\-\d)\.tar\.gz
