=== libs/mysql/CMakeLists.txt ===
--- 
+++ 
@@ -42,8 +42,8 @@
 	endif()
 	ExternalProject_Add(OpenSSL
 		${EP_CONFIGS}
-		URL https://www.openssl.org/source/openssl-1.1.0g.tar.gz
-		URL_MD5 ba5f1b8b835b88cadbce9b35ed9531a6
+		URL https://www.openssl.org/source/openssl-1.1.1.tar.gz
+		URL_MD5 7079eb017429e0ffb9efb42bf80ccb21
 		${OPENSSL_CONFS}
 		PATCH_COMMAND ${CMAKE_COMMAND} -Dopenssl_source=${CMAKE_BINARY_DIR}/libs/src/openssl -P ${CMAKE_SOURCE_DIR}/cmake/patch_openssl.cmake
 		SOURCE_DIR ${CMAKE_BINARY_DIR}/libs/src/openssl
@@ -88,8 +88,8 @@
 	ExternalProject_Add(MariaDBConnector
 		${EP_CONFIGS}
 		DEPENDS ${OPENSSL_DEP}
-		URL https://downloads.mariadb.org/f/connector-c-3.0.2/mariadb-connector-c-3.0.2-src.tar.gz
-		URL_MD5 2eb5ba004ac105eebb538ead352c0c78
+		URL https://downloads.mariadb.org/f/connector-c-3.0.9/mariadb-connector-c-3.0.9-src.tar.gz
+		URL_MD5 e7fdb17e26e779f4bd15b6a32e1c8472
 		CMAKE_ARGS
 			-Wno-dev
 			-DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES}
