=== debian/changelog ===
neko (2.3.0-1build3) jammy; urgency=medium

  * No-change rebuild against libmbedcrypto7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 18 Feb 2022 23:45:50 +0000

neko (2.3.0-1build2) hirsute; urgency=medium

  * Rebuild against new mariadb-10.5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 03 Dec 2020 21:57:01 +0100

neko (2.3.0-1build1) groovy; urgency=medium

  * No-change rebuild for libgc soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jul 2020 19:39:22 +0200

neko (2.3.0-1) unstable; urgency=medium

  * New upstream version.
  * Use https for information links.
  * Bump Standards-Version to 4.4.1.
    + Remove get-orig-source in d/rules.

 -- Andy Li <andy@onthewings.net>  Fri, 25 Oct 2019 21:47:31 +0800
