=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: neko
 Section: interpreters
 Priority: optional
-Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.1.3
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
+Standards-Version: 4.4.1
 Build-Depends:
 	debhelper (>= 9),
 	cmake,
@@ -20,7 +21,7 @@
 	bash-completion
 Vcs-Git: https://github.com/HaxeFoundation/neko-debian.git
 Vcs-Browser: https://github.com/HaxeFoundation/neko-debian
-Homepage: http://nekovm.org
+Homepage: https://nekovm.org
 
 Package: libneko2
 Architecture: any
