=== debian/rules ===
--- 
+++ 
@@ -32,6 +32,3 @@
 
 override_dh_missing:
 	dh_missing --fail-missing
-
-get-orig-source:
-	uscan --verbose --rename --force-download
